library(stockassessment)
load("run/model.RData")
FC<-list()

TAC <- 52884

Ay<-2015:2018
Ry<-1998:2017
Sy<-2015:2017

# Overwrite first two ave.years in landFrac so only the last value is taken forward in forecasts
fit$data$landFrac[(nrow(fit$data$landFrac)-2),] <- fit$data$landFrac[nrow(fit$data$landFrac),]
fit$data$landFrac[(nrow(fit$data$landFrac)-1),] <- fit$data$landFrac[nrow(fit$data$landFrac),]

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.24,0.29,0.31), ave.years=Ay, rec.years=Ry, label="Fsq, Fmsy HCR", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,NA,0.32,0.34), catchval=c(NA,42307,NA,NA), ave.years=Ay, rec.years=Ry, label="Fsq, EU MP (previous RPs)", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,NA,NA,0.29), catchval=c(NA,42307,33846,NA), ave.years=Ay, rec.years=Ry, label="Fsq, EU MP (current RPs)", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.0000001,0.0000001,0.0000001), ave.years=Ay, rec.years=Ry, label="Fsq, zero catch", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.39,0.39,0.39), ave.years=Ay, rec.years=Ry, label="Fsq, Fpa", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.54,0.54,0.54), ave.years=Ay, rec.years=Ry, label="Fsq, Flim", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,1,1), fval = c(NA,0.59119,NA,NA), ave.years=Ay, rec.years=Ry, label="Fsq, SSB(2020)=Blim", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,1,1), fval = c(NA,0.17371,NA,NA), ave.years=Ay, rec.years=Ry, label="Fsq, SSB(2020)=Bpa", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,1,1), fval = c(NA,0.17371,NA,NA), ave.years=Ay, rec.years=Ry, label="Fsq, SSB(2020)=Btrigger", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,0.8*TAC,0.8*TAC,0.8*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)-20%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,0.85*TAC,0.85*TAC,0.85*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)-15%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,0.9*TAC,0.9*TAC,0.9*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)-10%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,0.95*TAC,0.95*TAC,0.95*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)-5%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,TAC,TAC,TAC), ave.years=Ay, rec.years=Ry, label="Fsq, constant TAC", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,1.05*TAC,1.05*TAC,1.05*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)+5%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,1.1*TAC,1.1*TAC,1.1*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)+10%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,1.15*TAC,1.15*TAC,1.15*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)+15%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,1.2*TAC,1.2*TAC,1.2*TAC), ave.years=Ay, rec.years=Ry, label="Fsq, TAC(18)+20%", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), ave.years=Ay, rec.years=Ry, label="Fsq all years", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval = c(NA,0.198,0.198,0.198), ave.years=Ay, rec.years=Ry, label="Fsq, Fmsy lower", overwriteSelYears=Sy, splitLD=TRUE) 

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval = c(NA,0.31,0.31,0.31), ave.years=Ay, rec.years=Ry, label="Fsq, Fmsy", overwriteSelYears=Sy, splitLD=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval = c(NA,0.46,0.46,0.46), ave.years=Ay, rec.years=Ry, label="Fsq, Fmsy upper", overwriteSelYears=Sy, splitLD=TRUE)
                               
save(FC, file="run/forecast.RData")
